package com.javacodegeeks.example.scala.http

import org.scalatra._
import scala.collection._

class MyScalatraServlet extends ScalahttpexampleStack {

  get("/") {
    <html>
      <head>
      	<link rel="stylesheet" type="text/css" href="style.css"/>
      </head>
      <body>
        <h1>Hello, world!</h1>
        Say <a href="hello-scalate">hello to Scalate</a>.
      </body>
    </html>
  }

  get("/ssp-demo") {
  	//ssp("ssp-demo.ssp", "layout" -> "WEB-INF/templates/layouts/custom.ssp")
        //layoutTemplate("/WEB-INF/templates/views/index.ssp")

	ssp("ssp-demo.ssp")
  }

  get("/ssp-demo-html") {
  	contentType = "text/html"
	ssp("ssp-demo.ssp")
  }

  get("/http-get") {
  	val c = new Customer("Raghavan", "Muthu")
     	println("Customer :: " + c)
     	contentType = "text/html"
     	ssp("http-get.ssp", "customer" -> c)
  }

  get("/http-post") {
  	contentType = "text/html"
  	ssp("http-post.ssp")
  }

  var map:Map[String, Customer] = Map()

  post("/create") {
  	contentType = "text/html"
	var firstName = request.getParameter("firstName")
	var lastName = request.getParameter("lastName")
	println("REQUEST PARAMS :: firstName -> " + firstName + ", lastName -> " + lastName)
	val c = new Customer(firstName, lastName)
	map += (firstName -> c)
	println("Map :: " + map)
	ssp("http-post.ssp", "customer" -> c)
  }

  get("/http-getAll") {
  	contentType = "text/html"
	ssp("http-getAll.ssp", "customerMap" -> map)
  }
}

case class Customer(var firstName:String, var lastName:String) {
	override def toString = s"FirstName : " + firstName + ", LastName : " + lastName
}
